Changelog {#Changelog}
=========

# git master

# Release 2.1 (29-May-2017)

* [629](https://github.com/Eyescale/Equalizer/pull/629)
  Support deflect stereo streaming
* [619](https://github.com/Eyescale/Equalizer/pull/619)
  Fix running from an installed version
* [611](https://github.com/Eyescale/Equalizer/pull/611)
  Add eq::getHelp(), eq::Client::getHelp() and seq::Application::getHelp(),
  improve help for all applications
* [609](https://github.com/Eyescale/Equalizer/pull/609):
  Clean up magellan event API
* [608](https://github.com/Eyescale/Equalizer/pull/608):
  Make Frame::Buffer enum an enum class to ease bitmask handling;
  enum values are now Frame::Buffer::value instead of Frame::BUFFER_VALUE
* [607](https://github.com/Eyescale/Equalizer/pull/607):
  Implement view screenshot feature with eq::View::enableScreenshot()
* [606](https://github.com/Eyescale/Equalizer/pull/606):
  Remove unused big-endian/byteswap support
* [604](https://github.com/Eyescale/Equalizer/pull/604):
  Give ordered names to nodes in autogenerated configurations.
* [602](https://github.com/Eyescale/Equalizer/pull/602):
  Remove PBuffer support
* [601](https://github.com/Eyescale/Equalizer/pull/601):
  Add layout resize

# Release 2.0 (09-Dec-2016)

* [590](https://github.com/Eyescale/Equalizer/pull/590):
  Added key modifiers to pointer and key events.
* [564](https://github.com/Eyescale/Equalizer/pull/564):
  Implemented 2.0 event handling API
* [585](https://github.com/Eyescale/Equalizer/pull/585):
  Deflect proxy: update to Deflect 0.12 v5 API, use new PAN event to move
  camera instead of switching between pan/rotate with TAP_AND_HOLD event,
  handle new pinch event to zoom.
* [584](https://github.com/Eyescale/Equalizer/pull/584):
  Removed broken CUDA/ComputeContext support
* [578](https://github.com/Eyescale/Equalizer/pull/578):
  Application command line arguments are transmitted to render clients.
  Subsets of environmental variables can also be transmitted based on their
  prefixes.
* [574](https://github.com/Eyescale/Equalizer/pull/574):
  Deflect proxy: Consider DEFLECT_ID, use deflect env for render clients
* [572](https://github.com/Eyescale/Equalizer/pull/572):
  Sequel: Fix crash on exit
* [570](https://github.com/Eyescale/Equalizer/pull/570):
  Use new Collage launch code

# Release 1.12 (30-Jul-2016)

* [563](https://github.com/Eyescale/Equalizer/pull/563):
  Add seq::Renderer::requestRedraw()
* [561](https://github.com/Eyescale/Equalizer/pull/561):
  Change Deflect streaming activation

  * Use environment variable from
    [Deflect#98](https://github.com/BlueBrain/Deflect/pull/98)
  * Obsolete DisplayCluster view attributes, use deflect_host attribute now
* [560](https://github.com/Eyescale/Equalizer/pull/560):
  Add seq::Renderer::bindDrawFrameBuffer()
* [554](https://github.com/Eyescale/Equalizer/pull/554):
  Expose current view data in seq::Renderer
* [548](https://github.com/Eyescale/Equalizer/pull/548):
  Sequel tweaks for seqSplotch

  * configInit()/configExit() for eq::View
  * seq::Application::createViewData receives eq::View as parameter
  * seq::Renderer::createViewData receives eq::View as parameter
  * seq::ViewData considers eq::View::getModelUnit for model matrix manipulation


# Release 1.11 (21-Mar-2016)

* [542](https://github.com/Eyescale/Equalizer/pull/542):
  Fix missing/wrong handling of key events from Deflect host
* [538](https://github.com/Eyescale/Equalizer/pull/538):
  Support sorted image-based compositing. Minor API changes in the
  compositor, frame and image code
* [532](https://github.com/Eyescale/Equalizer/pull/532):
  Compositor::blendFrames() replaces Compositor::assembleFramesSorted()
* [529](https://github.com/Eyescale/Equalizer/pull/529):
  Pan/rotate mode switch for deflect::Proxy on tap & hold,
  add Channel::frameDrawOverlay()
* [529](https://github.com/Eyescale/Equalizer/pull/529):
  Add apply/resetOverlayState in Channel for 2D overlay rendering
* [527](https://github.com/Eyescale/Equalizer/pull/527):
  Fix Deflect wheel event to consider pixel delta from pinch
* [520](https://github.com/Eyescale/Equalizer/issues/520):
  Fix tile decomposition without ROI broken
* [518](https://github.com/Eyescale/Equalizer/pull/518):
  Enable customisation of client loop
* [511](https://github.com/Eyescale/Equalizer/pull/511):
  Fix exit behaviour on config parse error
* [510](https://github.com/Eyescale/Equalizer/issues/510):
  Fix async readback deadlock with direct send compositing

# Release 1.10 (5-Nov-2015)

* [508](https://github.com/Eyescale/Equalizer/pull/508):
  Post-divide alpha from pixels in eq::Image::writeImage()
* [504](https://github.com/Eyescale/Equalizer/pull/504):
  Let the OS choose the server port
* [502](https://github.com/Eyescale/Equalizer/pull/500):
  Fixed support of multi-pipe configurations in Qt
* [499](https://github.com/Eyescale/Equalizer/pull/499):
  Fixes for VirtualGL 2.4.80 with multi-pipe configurations
* [484](https://github.com/Eyescale/Equalizer/pull/484):
  Fix transfer window deadlock with Qt5
* [484](https://github.com/Eyescale/Equalizer/pull/484):
  Implement Window::doneCurrent() to make no OpenGL context current in the
  current thread
* [481](https://github.com/Eyescale/Equalizer/pull/481):
  Fix Config::getNextEvent() with definite timeout
* [467](https://github.com/Eyescale/Equalizer/issues/467):
  Fix CPU load with idle Qt-based windows
* [479](https://github.com/Eyescale/Equalizer/pull/479):
  Fix mouse wheel direction on AGL
* [476](https://github.com/Eyescale/Equalizer/issues/476):
  Fix slow readback of source channels with empty ROI
* [475](https://github.com/Eyescale/Equalizer/pull/475):
  Fix GL error on exit if frameWriter was used
* [473](https://github.com/Eyescale/Equalizer/pull/473):
  Fix OS X OpenGL detection
* [463](https://github.com/Eyescale/Equalizer/pull/463):
  Use program name as default window title
* [463](https://github.com/Eyescale/Equalizer/pull/463):
  Improved OpenGL and GLEW compatibility on OS X
* [463](https://github.com/Eyescale/Equalizer/pull/463):
  Fixed Qt5 support on OS X
* [463](https://github.com/Eyescale/Equalizer/pull/463):
  Standalone Qt5 support

# Release 1.9 (7-Jul-2015)

* [462](https://github.com/Eyescale/Equalizer/pull/462):
  Add eq::Client::addActiveLayout to tweak default autoconfigured layout
* [461](https://github.com/Eyescale/Equalizer/pull/461):
  Allow custom filename for SATTR_DUMP_IMAGE, use OSG to write different image
  formats
* [458](https://github.com/Eyescale/Equalizer/pull/458):
  Add byteswap for unsigned int vectors
* [453](https://github.com/Eyescale/Equalizer/pull/453),
  [440](https://github.com/Eyescale/Equalizer/pull/440):
  Port to Qt5 using new GL classes
* [447](https://github.com/Eyescale/Equalizer/pull/447):
  Sequel extensions for stardust
* [437](https://github.com/Eyescale/Equalizer/pull/437):
  System window and example for CPU-based rendering.
* [434](https://github.com/Eyescale/Equalizer/pull/434):
  #[60](https://github.com/Eyescale/Equalizer/issues/60):
  Multisample FBO support
* [431](https://github.com/Eyescale/Equalizer/pull/431):
  VGL_EXCLUDE for non-display GPUs
* [429](https://github.com/Eyescale/Equalizer/pull/429):
  Remove channel FBO drawable; use window hint_drawable FBO instead
* [428](https://github.com/Eyescale/Equalizer/pull/428):
  Implement support for OpenGL core context creation
  #[156](https://github.com/Eyescale/Equalizer/issues/156)
* [426](https://github.com/Eyescale/Equalizer/pull/426):
  EqGLLibraries: export correct GLEW_MX lib
* [425](https://github.com/Eyescale/Equalizer/pull/425):
  Fix NPR in --eq-layout code
* [417](https://github.com/Eyescale/Equalizer/pull/417):
  Improve auto placement on dual-screen setups
* [415](https://github.com/Eyescale/Equalizer/pull/415):
  Add eq::ResultImageListener to intercept destination channel rendering
* [409](https://github.com/Eyescale/Equalizer/pull/409):
  Switch to separated Deflect library
* [407](https://github.com/Eyescale/Equalizer/pull/407),
  [405](https://github.com/Eyescale/Equalizer/pull/405),
  [399](https://github.com/Eyescale/Equalizer/pull/399):
  Denoise log outputs
* [405](https://github.com/Eyescale/Equalizer/pull/405),
  [392](https://github.com/Eyescale/Equalizer/pull/392):
  Fix async texture readback
* [400](https://github.com/Eyescale/Equalizer/pull/400):
  Allow sharing with external/non-EQ managed QGLWidgets
* [397](https://github.com/Eyescale/Equalizer/pull/397):
  Added ERROR_FRAMEBUFFER_INVALID_SIZE error when creating FBO with invalid size
* [395](https://github.com/Eyescale/Equalizer/pull/395):
  Fix semantics of Config::update()
* [394](https://github.com/Eyescale/Equalizer/pull/394):
  Allow set of entire window settings; can be useful to transfer settings in the
  admin side
* [392](https://github.com/Eyescale/Equalizer/pull/392):
  Add default connection for autoconfigured server
* [391](https://github.com/Eyescale/Equalizer/pull/391):
  Complete instantiations for eq::admin::Config::find<>
* [390](https://github.com/Eyescale/Equalizer/pull/390):
  Fix build w/ OpenCV
* [389](https://github.com/Eyescale/Equalizer/pull/389):
  Server library no longer depends on client library, use local server directly
  from server library rather than dlopen it
* [385](https://github.com/Eyescale/Equalizer/pull/385):
  Fix offscreen Qt window: viewport and transfer window
* [383](https://github.com/Eyescale/Equalizer/pull/383):
  Make discovery for resources, plugins and server library relocatable
* [382](https://github.com/Eyescale/Equalizer/pull/382):
  Make DisplayCluster a View attribute that can be set by a global/env var.
* [381](https://github.com/Eyescale/Equalizer/pull/381):
  Fix Win32 build w/ Qt, fix mouse buttons & wheel with WGL
* [380](https://github.com/Eyescale/Equalizer/pull/380):
  Fix static initialization problem w/ Qt window system

# Release 1.8 (14-Oct-2014)

* Implemented Qt window system for onscreen windows. Issue
  [21](https://github.com/Eyescale/Equalizer/issues/21) partially done.
* DisplayCluster streaming can be enabled with automatic configuration using new
  global view attributes: EQ_VIEW_SATTR_DISPLAYCLUSTER and
  EQ_VIEW_SATTR_PIXELSTREAM_NAME.
* New EqGLLibraries.cmake script for simpler OpenGL configuration in
  downstream projects
* Compression is enabled for DisplayCluster streaming
* DisplayCluster streaming is now asynchronous
